#include <String.h>

#define LED 13
#define bassBotPin 2
#define snareBotPin 3
#define xyloBotPin0 8
#define xyloBotPin1 9
#define xyloBotPin2 10
#define xyloBotPin3 11
#define xyloBotHit 12

#include "WProgram.h"
void setup();
void loop();
int getCharNumber(char c);
char FLUTOPHONE = '4';
char XYLOBOT = '3';
char SNAREBOT = '2';
char BASSBOT = '1';
char HEADER = '~';

char alphabet[27] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  
char val;
char instrument;
char note;

void setup()
{
  Serial.begin(9600);//REMEMBER, REVERSE LOGIC!!!
  pinMode(bassBotPin, OUTPUT);
  digitalWrite(bassBotPin,HIGH);
  pinMode(snareBotPin, OUTPUT);
  digitalWrite(snareBotPin,HIGH);
  pinMode(xyloBotPin0, OUTPUT);
  digitalWrite(xyloBotPin0,HIGH);
  pinMode(xyloBotPin1, OUTPUT);
  digitalWrite(xyloBotPin1,HIGH);
  pinMode(xyloBotPin2, OUTPUT);
  digitalWrite(xyloBotPin2,HIGH);
  pinMode(xyloBotPin3, OUTPUT);
  digitalWrite(xyloBotPin3,HIGH);
  pinMode(xyloBotHit, OUTPUT);
  digitalWrite(xyloBotHit,HIGH);
}

void loop()
{
  if(Serial.available()){
    val = Serial.read();
    if(val == HEADER){//GET READY TO READ IN THE DATA!!
    
      while(1){//read instrument
        if(Serial.available()){
          instrument = Serial.read();
          break;
        }
      }
      while(1){//read note
        if(Serial.available()){
          note = Serial.read();
          break;
        }
      }
      //Serial.flush();
      digitalWrite(LED,LOW);
      
      
      if(instrument == BASSBOT) {//CHECK BASSBOT ~NOTE REVERSE LOGIC~
        if(note == 'A'){
          digitalWrite(bassBotPin,LOW);//Send start hit signal
          digitalWrite(LED,HIGH);//flag an activation
        } else if(note == 'Z'){
          digitalWrite(bassBotPin,HIGH);//send dont start hit signal
        }
      }
      
      
      if(instrument == SNAREBOT) {//CHECK SNAREBOT ~NOTE REVERSE LOGIC~
        if(note == 'A'){
          digitalWrite(snareBotPin,LOW);//hit
          digitalWrite(LED,HIGH);//flag an activation
        } else if(note == 'Z'){
          digitalWrite(snareBotPin,HIGH);//don't it
        }
      }
      
      
      if(instrument == XYLOBOT) {//CHECK XYLOBOT ~NOTE REVERSE LOGIC~
        int noteNumber = getCharNumber(note);
        if(noteNumber == 26){
          noteNumber = 0;
        }
        if(noteNumber > 0){
          digitalWrite(LED,HIGH);//receiving instrument data
        }
        if(noteNumber >= 8){
          digitalWrite(xyloBotPin3,LOW);
          noteNumber -= 8;
          Serial.print("1");
        } else {
          digitalWrite(xyloBotPin3,HIGH);
          Serial.print("0");
        }
        if(noteNumber >= 4){
          digitalWrite(xyloBotPin2,LOW);
          noteNumber -= 4;
          Serial.print("1");
        } else {
          digitalWrite(xyloBotPin2,HIGH);
          Serial.print("0");
        }
        if(noteNumber >= 2){
          digitalWrite(xyloBotPin1,LOW);
          noteNumber -= 2;
          Serial.print("1");
        } else {
          digitalWrite(xyloBotPin1,HIGH);
          Serial.print("0");
        }
        if(noteNumber >= 1){
          digitalWrite(xyloBotPin0,LOW);
          noteNumber -= 1;
          Serial.println("1");
        } else {
          digitalWrite(xyloBotPin0,HIGH);
          Serial.println("0");
        }
        digitalWrite(xyloBotHit,LOW);
      }
      
      
      delay(10);
      digitalWrite(bassBotPin,HIGH);
      digitalWrite(snareBotPin,HIGH);
      digitalWrite(xyloBotHit,HIGH);
      digitalWrite(xyloBotPin0,HIGH);
      digitalWrite(xyloBotPin1,HIGH);
      digitalWrite(xyloBotPin2,HIGH);
      digitalWrite(xyloBotPin3,HIGH);
    }
  }
}

int getCharNumber(char c){
  for(int i = 0; i < 26; ++i){
    if(alphabet[i] == c){
      return i+1;
    }
  }
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

